from math   import sqrt
from mcdemo import run_trials, mt19937p, sgenrand

def run_mc(rtol = 1e-2, maxtrials = 1000000, nbatch = 500):
    """Run a Monte Carlo experiment based on run_trials from mcdemo
    """
    mt = mt19937p()
    sgenrand(100,mt)
    all_sum_X = 0
    all_sum_X2 = 0
    ntrials = 0
    errest = 2*rtol
    EX = 1
    while ntrials < maxtrials and errest > rtol*abs(EX):
        sum_X, sum_X2 = run_trials(mt,nbatch)
        all_sum_X  = all_sum_X  + sum_X
        all_sum_X2 = all_sum_X2 + sum_X2
        ntrials    = ntrials + nbatch
        EX   = all_sum_X /ntrials
        EX2  = all_sum_X2/ntrials
        stdX = sqrt(EX2-EX*EX)
        errest = stdX/sqrt(ntrials)
    return EX, errest
